// Test des passes à macro rugosité pour JaLHyd
clear
sCurrentPath = get_absolute_file_path("main_macrorugo.sce");
getd(sCurrentPath);

bDbg = %f;

// Tests parameters
ks = 0.01 // Rugosité de fond (m)
Cd0=1.5 // Forme
S = 0.05 // Pente
C = 0.13; // Concentration
D = 0.5; // Diamètre
B = 1 // Largeur
z_amont = 12.5; // Cote amont (m)
long = 6; // Longueur rampe (m)

// *****************************************************************************
printf("\n*** Emergent conditions Cd=1.5***\n")
// *****************************************************************************
h = 0.6
k = 0.7
Cd0 = 1.5
macrorugo_searchQ(ks, D, k, Cd0, S, B, h, C, z_amont, long, bDbg)

// *****************************************************************************
printf("\n*** Emergent conditions Cd=2***\n")
// *****************************************************************************
h = 0.6
k = 0.7
Cd0 = 2
macrorugo_searchQ(ks, D, k, Cd0, S, B, h, C, z_amont, long, bDbg)

// *****************************************************************************
printf("\n*** Submerged conditions ***\n")
// *****************************************************************************
k = 0.7
h = 0.8
Cd0 = 1.5
macrorugo_searchQ(ks, D, k, Cd0, S, B, h, C, z_amont, long, bDbg)

