/**
 * IMPORTANT !
 * Décommenter temporairement la ligne suivante (import { } from "./mock_jasmine")
 * Pour exécuter ce code dans le débugger.
 * Faire de même avec le fichier test_func.ts
 */
// import { describe, expect, it, xdescribe, xit } from "../mock_jasmine";

import { ParamDefinition } from "../../src/param/param-definition";
import { SectionParametree } from "../../src/section/section_parametree";
import { cSnRectang, ParamsSectionRectang } from "../../src/section/section_rectang";
import { precDist } from "../test_config";

function createSection(prec: number) {
    return new SectionParametree(
        new cSnRectang(
            new ParamsSectionRectang(
                0.8, // tirant d'eau
                2.5, // largeur de fond
                40, //  Ks=Strickler
                1.2,  //  Q=Débit
                0.001, //  If=pente du fond
                1, // YB= hauteur de berge
            )
        )
    );
}

function testVarier(nub: SectionParametree, p: ParamDefinition) {
    // variation de p
    // vérifier que le calcul se déroule correctement et que les résultats complémentaires sont tous calculés
    it("en variant " + p.symbol + ", tous les résultats complémentaires devraient être présents", () => {
        // console.log(">>>>>>>>>>>>>>>> variating", p.symbol);
        p.setValues(1, 5, 0.5);
        nub.CalcSerie();
        expect(nub.result).toBeDefined();
        expect(nub.result.resultElements.length).toBe(9);

        // console.log(Object.keys(nub.result.resultElements[0].extraResults));
        // console.log(nub.result.resultElements);
        // tslint:disable-next-line:prefer-for-of
        for (let i = 0; i < nub.result.resultElements.length; i++) {
            expect(Object.keys(nub.result.resultElements[i].extraResults).length).toBe(17);
        }
    });
}

describe("Section paramétrée rectangulaire, paramètres fixés : ", () => {

    it("tous les résultats complémentaires devraient être présents", () => {
        const nub = createSection(precDist);
        nub.CalcSerie();
        expect(nub.result).toBeDefined();
        expect(Object.keys(nub.result.resultElements[0].extraResults).length).toBe(17);
    });
});

describe("Section paramétrée rectangulaire, paramètres variés : ", () => {

    const nub = createSection(precDist);
    for (const p of nub.parameterIterator) {
        if (p.symbol !== "Pr") {
            testVarier(nub, p);
        }
    }
});
