/**
 * IMPORTANT !
 * Décommenter temporairement la ligne suivante (import { } from "./mock_jasmine")
 * Pour exécuter ce code dans le débugger.
 * Faire de même avec le fichier test_func.ts
 */
// import { describe, expect, it, xdescribe, xit } from "../mock_jasmine";

import { Structure, StructureParams } from "../../src/structure/structure";
import { Result } from "../../src/util/result";

class StructureTest extends Structure {

    constructor(prms: StructureParams, dbg: boolean = false) {
        super(prms, dbg);
    }

    /**
     * Test of getFlowMode
     */
    public testGetFlowMode() {
        this.prms.update_h1h2();
        return this.getFlowMode();
    }

    /**
     * Test of getFlowRegime
     */
    public testGetFlowRegime() {
        this.prms.update_h1h2();
        return this.getFlowRegime();
    }

    public CalcQ(): Result {
        this.prms.update_h1h2();
        const data = this.getResultData();

        return new Result(this.prms.Z1.v - this.prms.Z2.v - this.prms.ZDV.v, this, data);
    }

    /**
     * Calcul de l'aire d'écoulement sur le seuil ou dans l'orifice
     */
    public calcA(): number {
        return Math.min(Math.max(this.prms.h1.v, this.prms.h2.v), this.prms.W.v);
    }

}

/* Test structure with :
 *  - ZDV = 0
 *  - Z1 = 30
 *  - Z2 = 15
 *  - expected Q = 15
 */
export const structTestPrm: StructureParams = new StructureParams(1, 0, 30, 15);
export const structTest: StructureTest = new StructureTest(structTestPrm, false);
